/***************************************************************************
                          kquick.cpp  -  description
                             -------------------
    begin                : Mit Dez 22 03:21:27 CET 1999
    copyright            : (C) 1999 by Philipp Ghring
    email                : p.guehring@poboxes.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "kquick.h"
#include <khtml_part.h>
#include <qlayout.h>
#include <qlineedit.h>
#include <qclipboard.h>
#include <kcursor.h>
#include <kprocess.h>
#include <kwin.h>
#include <kmainwindow.h>
#include <kmenubar.h>
#include <klocale.h>

#include <stdlib.h>
#include <dirent.h>
#include <sys/stat.h>

bool logQueries;
bool AutoOnTop;

/**
      * QString myHTMLCode = ...;
 * KHTMLPart *w = new KHTMLPart();
 * w->begin();
 * w->write(myHTMLCode);
 * ...
 * w->end();
    */

KQuick::KQuick(QWidget* parent=0, const char *name=0)
{
  parent=parent; name=name;
  TestDir( "/.kde" );
  TestDir( "/.kde/share" );
  TestDir( "/.kde/share/config" );
  TestDir( "/.kde/share/apps" );
  QString dir( "/.kde/share/apps/kquick/" );
  TestDir( dir );
  logfile=NULL;
  QString filename = getenv( "HOME" );
  filename += "/.kde/share/apps/kquick/log.txt";
  //printf (i18n("Filename: %s\n"),(const char *)filename);
  if (logQueries)
  {
    logfile=fopen(filename,"a");
  };

  quick=new Quick();
  CountDown=0;

  topWidget=new QWidget(this);
  editbox=new QLineEdit(topWidget);
  editbox->setMinimumSize(QSize(10,20));
  editbox->setMaximumSize(QSize(1000,20));

  htmlw=NULL;
  htmlw=new KHTMLPart(topWidget);
  htmlw->setURLCursor( KCursor::handCursor() );
  //htmlw->setFocusPolicy(QWidget::NoFocus);

  output=new OutputC(htmlw);

//  connect(htmlw, SIGNAL(urlSelected(const QString &, int, int, const QString &)), SLOT(slotLoadUrl(const QString &, int, int, const QString &)));
  connect(htmlw, SIGNAL(onURL(const QString &)), SLOT(slotOnURL(const QString &)));

  QBoxLayout *topLayout=new QBoxLayout(topWidget,QBoxLayout::TopToBottom,1);
  topLayout->addWidget(editbox);
  topLayout->addWidget(htmlw->widget(),0,0);
  topLayout->activate();
  setView(topWidget);

  QPopupMenu *filemenu=new QPopupMenu();
  filemenu->insertItem(i18n("E&xit"),kapp,SLOT(quit() ) );
  menuBar()->insertItem(i18n("&File"),filemenu);

  optionmenu=new QPopupMenu();
  optionmenu->setCheckable(true);
  optionmenu->insertItem(i18n("&Log Queries"),this,SLOT(switchlog() ),0,1 );
  optionmenu->setItemChecked(1,logQueries);
  optionmenu->insertItem(i18n("&Auto On Top"),this,SLOT(switchontop() ),0,2 );
  optionmenu->setItemChecked(2,AutoOnTop);
    menuBar()->insertItem(i18n("&Options"),optionmenu);
    menuBar()->insertItem(i18n("&Help"),helpMenu(i18n("Kquick, a *Quick interface for KDE\n(C) 2000 Philipp Ghring\nbased on Babytrans from Frederic Jolliton, which is under the GPL.\nLicense: GPL\nTeam:\nPhilipp Ghring\nFrederic Jolliton\nGregor Mckl\nRoman Spitzbart\nMarco Schild\n\n"),true) );

  //htmlw->setScrolling(1);

  if (quick->Translators==NULL)
  {
    htmlw->begin("/tmp/kquick.html");
    htmlw->write("<head>\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n");
    htmlw->write("</head>\n<body><font size=\"+1\" face=\",helvetica,arial\">");
    htmlw->write(i18n("<font color=\"#FF0000\">No databases found!<P> Please download databases from <a href=\"http://www.futureware.at/kquick.htm\">http://www.futureware.at/kquick.htm</a> and install them under /usr/share/trans/ .</font>\n"));
    htmlw->write("</font></body></html>");
    htmlw->end();
//    htmlw->parse();
  }
  else
  {
printf("TEST1\n");
    #ifdef QUICKPOLLING
    startTimer(400); // alle 500 Millisekunden
    timerEvent(NULL);
    #else
    clip = kapp->clipboard();
    connect(clip,SIGNAL(dataChanged()),this,SLOT(slot_ClipChanged()));
    #endif
  };

  //topLayout->show();
}

KQuick::~KQuick()
{
}


/** Gibt regelmig HTML Code aus */
#ifdef QUICKPOLLING
void KQuick::timerEvent(QTimerEvent *ev)
#else
void KQuick::slot_ClipChanged()
#endif
{
  //ev=ev;
  QString searchtext, edittext;
  QString h;
  searchtext=QApplication::clipboard()->text();
  if (searchtext!=lastsearch)
  {
    editbox->validateAndSet(searchtext,0,0,0);
    lastsearch=searchtext;
  }
  edittext=editbox->text();
  edittext=edittext.simplifyWhiteSpace();
  if (edittext!=lastedit)
  {
    lastedit=edittext;
    CountDown=4; //COUNTDOWN MUSS NEU BERDACHT WERDEN!
  }
  if (CountDown) CountDown--;
  if (CountDown==1)
  {
    int nResults=0;

    if (logfile!=NULL)
      fprintf(logfile,"%s\n",(const char *)edittext);

//	  slotStatusMsg(i18n("Searching ..."));

    htmlw->begin("acronym:");

    //change UTF-8 to Latin1 if needed
    htmlw->write("<head>\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n");
    htmlw->write("<TITLE>KQuick</TITLE>\n</head>\n<body bgcolor=\"#fbf8f1\" background=\"file:/usr/share/trans/backgr.gif\"><font size=\"+1\" face=\"helvetica,arial\">");
    htmlw->write("<style type=\"text/css\">body {background-image: url(/usr/share/trans/backgr.gif);background-repeat: no-repeat;background-position: center center;background-attachment: fixed}</style>\n");
    //h.Format("<a href=\"http://www.futureware.at/quick.htm\"><img src=\"file:%s/quick.xpm\" alt=\"*Quick Logo\" width=65 height=25 border=0></a>\n",(const char *)kapp->kde_icondir());
    htmlw->write(h);

    if(!strlen(edittext))
    {
      htmlw->write(i18n("from <a href=\"http://www.futureware.at/efuture.htm\">Futureware 2001</a></P>"));
      htmlw->write(i18n("<P>Simply mark the word/acronym you want to have translated.</P>"));
      htmlw->write(i18n("<P><font size=\"-1\"><a href=\"quick?info:\">Information</a> about all the databases.</font></P>"));
      //htmlw->write(i18n("<P>KQuick is derived from <a href=\"http://fjolliton.free.fr/babytrans\">Babytrans</a> from <a href=\"mailto:fjolliton@free.fr\">Frederic Jolliton</a>.</P>"));
      htmlw->write(i18n("<P><font size=\"+2\">DONT PANIC</font></P>"));
    }

    if(strlen(edittext))
    {
      htmlw->write("</P>");
      nResults=quick->search(l2u(edittext),output);
    }

    htmlw->write("</font></body></html>\n");
    htmlw->end();
    //htmlw->parse();
    htmlw->show();

//    slotStatusMsg(i18n(IDS_STATUS_DEFAULT));

//    if(nResults && AutoOnTop) KWM::raise(winId());

    /* Dies ist ein Hack, weil KWM::raise in dieser Form nicht mehr exisitert */
    if(nResults && AutoOnTop) {
      KWin::setState(winId(),NET::StaysOnTop);
      KWin::clearState(winId(),NET::StaysOnTop);
    }
  }

}

// ----------------------------------------------------------------------------
// Function:    TestDir (const char* name)
// Parameters:  name    - Path to directory to test for/create underneath $HOME
// ----------------------------------------------------------------------------
/** Tests for the existence of a given directory underneath $HOME and creates it
 if it doesn't exist. */
// ----------------------------------------------------------------------------
void KQuick::TestDir(const char* name)
{
    DIR* dp;
    QString dir = getenv( "HOME" );
    dir += name;

    dp = opendir( dir );
    if (dp == NULL)
        mkdir( dir, S_IRWXU );
    else
        closedir( dp );
}


/** Switches the logging on and off */
void KQuick::switchlog(){
  logQueries=!logQueries;
  optionmenu->setItemChecked(1,logQueries);
//  kapp->getConfig()->writeEntry("LogQueries",logQueries);

  //printf (i18n("Filename: %s\n"),(const char *)filename);
  if (logQueries)
  {
    QString filename = getenv( "HOME" );
    filename += "/.kde/share/apps/kquick/log.txt";
    logfile=fopen(filename,"a");
  }
  else
  {
    if (logfile!=NULL) fclose(logfile);
    logfile=NULL;
  }

};


/** Switches the logging on and off */
void KQuick::switchontop(){
  AutoOnTop=!AutoOnTop;
//  optionmenu->setItemChecked(2,AutoOnTop);
//  kapp->getConfig()->writeEntry("AutoOnTop",AutoOnTop);
};


/** load document from url */
void KQuick::loadUrl(const QString &_url,bool saveRecent=true)
{
  QString url=_url;
  saveRecent=saveRecent;
  char *ignorelist[]={"/cgi-bin/","acronym:/","quick?","kquick?","cquick?","wquick?","q=","#",NULL};
  char **ignore=ignorelist;

  while(*ignore)
  {
    if( url.left(strlen(*ignore)) == *ignore )
    {
      url.remove(0,strlen(*ignore));
    }

    ignore++;
  }
  if( url.left(5)=="http:" || url.left(7)=="mailto:" || url.left(4)=="ftp:" ) {
  	KProcess showHtml;
  	showHtml << "kfmclient" << "exec" << url.data();
  	showHtml.start( KProcess::DontCare);
  }
#if 0
  else if ( url.left(5) == "file:" ) {
  	  _url+=5; // cut file://
  	  char anchor[128];
  	  *anchor=0;
  		
  	  if ( char *end = strstr(_url,"#") ) {
  	  	strncpy(anchor,end+1,128);
  	  	*end = 0;
  	  }
  		  		
  		QFile fileToOpen(_url);
   		if( fileToOpen.exists())
   		{
   			//doc->openDocument(_url);
    		QString caption=kapp->getCaption();	
     		setCaption(caption+": "+doc->getTitle());
     		
     		//if ( saveRecent ) addRecentURL( url );
     		
     		if ( posURL == 0 )
     					disableCommand(ID_VIEW_FORWARD);
     		else
     					enableCommand(ID_VIEW_FORWARD);
     					
     		if ( posURL+1 ==  (int)recentURLs.count() )
     					disableCommand(ID_VIEW_BACK);
     		else
     					enableCommand(ID_VIEW_BACK);
     					
      		
     		if (*anchor)
     			html->gotoAnchor(anchor);
    	}
  }
#endif
  else
    editbox->validateAndSet(url.data(),0,0,0); //This is what the ignore list finally uses! Dont forget it!

}

/** Load document from Url
when You select link in preview window */
void KQuick::slotLoadUrl (const QString &_url, int _button, int _dummy, const QString &_target )
{
  _button=_button;_dummy=_dummy;
	//slotStatusMsg(i18n("Loading file from URL..."));
  loadUrl(_url);
  //slotStatusMsg(i18n(IDS_STATUS_DEFAULT));
}

/** connected to KHtmlView onURL signal */
void KQuick::slotOnURL (const QString &_url )
{
	//slotStatusMsg(QString(_url));
}

