/***************************************************************************
                          quick.cpp  -  description
                             -------------------
    begin                : Sat Apr 1 2000
    copyright            : (C) 2000 by Philipp Ghring
    email                : p.guehring@poboxes.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include "stdafx.h"

//const char *i18n(const char *Text);
//#define i18n i18n
#include <kapp.h>
#include <klocale.h>

#include "quick.h"
#include "outputc.h"

#ifdef __unix__
#include <dirent.h>
#include <sys/stat.h>
#endif

#include "libbab.h"
#include "binaryc.h"

/**Does the internationalisation on all platforms */
/*
const char *i18n(const char *Text)
{
#if defined(__unix__) && defined(KDE1)
  if ((KApplication::getKApplication())!=NULL && (KApplication::getKApplication()->getLocale())!=NULL )
    return KApplication::getKApplication()->getLocale()->translate(Text);
#endif

  return Text;
}
*/
/**Latin1 to Unicode(UTF-8) */
QString l2u(const char *Latin1)
{
  QString Puffer;
  if(Latin1==NULL) return Puffer; //The question what to return is not easy. Perhaps we should return NULL ...
  while(*Latin1)
  {
    if(*Latin1>=0)
      Puffer += *Latin1++;
    else
    {
      Puffer +=(((*Latin1)&0xC0)>>6)|0xC0;
      Puffer +=((*Latin1)&0x3F)|0x80;
      Latin1++;
    };
  }
  return Puffer;
}

Quick::Quick()
{
#ifdef __unix__
  struct dirent **namelist;
  int n;
#endif

  Translators=NULL;
  Act=&Translators;

#ifdef FindFirstFile
  WIN32_FIND_DATA fd;
  HANDLE hFind = NULL;
#define BASEDIR "C:\\Programme\\WQuick\\"
#define PLAIN BASEDIR "plain\\"
#define BABYLON BASEDIR "babylon\\"
  if ((hFind = FindFirstFile (PLAIN "*", &fd)) != INVALID_HANDLE_VALUE)
  { 
    if (fd.cFileName[0]!='.')
      Insert(new BinaryC(PLAIN,fd.cFileName));

    while (FindNextFile (hFind, &fd)) if (fd.cFileName[0]!='.')
    {
      Insert(new BinaryC(PLAIN,fd.cFileName,0));
	}
  }
  if ((hFind = FindFirstFile (BABYLON "*", &fd)) != INVALID_HANDLE_VALUE)
  { 
    if (fd.cFileName[0]!='.' && strcmpi("english.dic",fd.cFileName))
      Insert(new BabylonC(BABYLON,fd.cFileName));

    while (FindNextFile (hFind, &fd)) if (fd.cFileName[0]!='.' && strcmpi("english.dic",fd.cFileName))
    {
      Insert(new BabylonC(BABYLON,fd.cFileName));
	}
  }
#else

//  char *Dirs[]={"/usr/share/trans/",".trans/","/windows/C/Programme/WQuick/","/cdrom/","",NULL};
  char *Dirs[]={"/usr/share/trans/","",NULL};

  int i=0;

  for (i=0;Dirs[i]!=NULL;i++)
  {
    QString dir;

    dir.Format("%s%s",Dirs[i],"plain/");
    n = scandir(dir, &namelist, 0, alphasort);
    if (n >= 0)
      while(n--) if (namelist[n]->d_name[0]!='.')
        Insert(new BinaryC(dir,namelist[n]->d_name,0));
  
    dir.Format("%s%s",Dirs[i],"binary/");
    n = scandir(dir, &namelist, 0, alphasort);
    if (n >= 0)
      while(n--) if (namelist[n]->d_name[0]!='.')
        Insert(new BinaryC(dir,namelist[n]->d_name,0xFF));
  
    dir.Format("%s%s",Dirs[i],"babylon/");
    n = scandir(dir, &namelist, 0, alphasort);

    if (n >= 0)
      while(n--)
         if (namelist[n]->d_name[0]!='.')
            if (strcasecmp("english.dic",namelist[n]->d_name))
              Insert(new babylon(dir,namelist[n]->d_name));

  }
#endif
}

Quick::~Quick()
{
  delete Translators;
}

/** Fgt TranslatorKlasse in die Liste ein */
void Quick::Insert(TransC *Clas){
  *Act=new TransCList(Clas);
  Act=&((*Act)->Next);
}

/**style: 0-> HTML Output, 1-> Text Output, 2-> Thesaurus/Word Style (only one word in one line, no HTML)*/
int Quick::search(const char *p_word,OutputC *htmlw,int style)
{
  int found=0;
  for(TransCList *i=Translators;i!=NULL;i=i->Next)
    found+=i->Tran->search(p_word,htmlw,style);


  if (style<1 && !found)
    htmlw->write(i18n("Nothing found! Please try to mark the word exactly.<P>"));

  if (style==0)
  {
      htmlw->write(i18n("Search at"));

      htmlw->write(" <a href=\"http://dict.leo.org/?search=");
      htmlw->write(p_word);
      htmlw->write("&lang=en\">dict.leo.org</a>");

//      htmlw->write(" <a href=\"http://TransBot.com/trans?wort=");
//      htmlw->write(p_word);
//      htmlw->write("\">TransBot</a>");

      htmlw->write(" <a href=\"http://www.h2g2.com/Search?searchstring=");
      htmlw->write(p_word);
      htmlw->write("&searchtype=ARTICLE&skip=0&show=20&showapproved=1&shownormal=1&showsubmitted=1\">H2G2</a>");

      htmlw->write(" <a href=\"http://www.whatis.com/WhatIs_Search_Results_Exact/1,282033,,00.html?query=");
      htmlw->write(p_word);
      htmlw->write("\">WhatIs</a>");

      htmlw->write(" <a href=\"http://www.altavista.com/cgi-bin/query?q=");
      htmlw->write(p_word);
      htmlw->write("\">Altavista</a>");

      htmlw->write(" <a href=\"http://suche.web.de/search/?su=");
      htmlw->write(p_word);
      htmlw->write("\">WEB.DE</a>");

      htmlw->write(" <a href=\"http://www.webcrawler.com/cgi-bin/WebQuery?searchText=");
      htmlw->write(p_word);
      htmlw->write("\">WebCrawler</a>");

      htmlw->write(" <a href=\"http://www.google.com/search?q=");
      htmlw->write(p_word);
      htmlw->write("\">Google</a>");

      htmlw->write(" <a href=\"http://www.mckinley.com/extsearch.cgi?query=");
      htmlw->write(p_word);
      htmlw->write("\">Magellan</a>");

      htmlw->write(" <a href=\"http://search.yahoo.com/bin/search?p=");
      htmlw->write(p_word);
      htmlw->write("\">Yahoo</a>");

      htmlw->write(" <a href=\"http://www.speech.cs.cmu.edu/cgi-bin/cmudict?in=");
      htmlw->write(p_word);
      htmlw->write("\">CMU</a>");

      htmlw->write(" <a href=\"http://www.acronymfinder.com/af-query.asp?Acronym=");
      htmlw->write(p_word);
      htmlw->write("\">AcronymFinder</a>");

      htmlw->write("<p>Submit a <a href=\"http://quick.futureware.at/cgi-bin/problem?q=");
      htmlw->write(p_word);
      htmlw->write("\">Problem</a> with the translation");
  }
  return found;
}
